/**
 * @summary Main JS of Wish list for WooCommerce plugin.
 *
 * This js is mainly responsible for adding / removing WooCommerce product items from Wish list through Ajax,
 * and to show a notification to user when Ajax response is complete.
 *
 * @version   1.5.9
 * @since     1.0.0
 * @requires  jQuery.js
 */
alg_wc_wl_get_toggle_wishlist_item_data=function(t){return data={action:alg_wc_wl_ajax.action_toggle_item,unlogged_user_id:alg_wc_wish_list.get_cookie("alg-wc-wl-user-id"),alg_wc_wl_item_id:t.attr("data-item_id")},data};var alg_wc_wish_list={};jQuery(function(t){alg_wc_wish_list={init:function(){t(document.body).on("mouseup touchend",alg_wc_wl_toggle_btn.btn_class,this.toggle_wishlist_item),this.handle_item_removal_from_wishlist_page(),this.setup_izitoast();var o=this.get_notification_option("toggle_item_return");o&&alg_wc_wish_list.show_notification(o),t("body").on("alg_wc_wl_toggle_wl_item",this.removeItemFromDomOnThumbBtnClick),t("body").on("alg_wc_wl_copied_to_clipboard",this.notify_on_copy_to_clipboard)},notify_on_copy_to_clipboard:function(t){alg_wc_wish_list.show_notification({data:{message:alg_wc_wish_list.get_notification_option("copied_message"),icon:alg_wc_wl.fa_icons.copy}})},removeItemFromDomOnThumbBtnClick:function(o){if(jQuery(o.target).hasClass("is_wish_list")&&jQuery(o.target).hasClass("wish_list_wc_template")){var i=jQuery(o.target).closest(".product");i.remove(),t("body").trigger({type:"alg_wc_wl_remove_item",item_id:o.target.attr("data-item_id"),target:o.target,removed_item:i})}},get_cookie:function(t){for(var o=t+"=",i=decodeURIComponent(document.cookie),e=i.split(";"),_=0;_<e.length;_++){for(var n=e[_];" "==n.charAt(0);)n=n.substring(1);if(0==n.indexOf(o))return n.substring(o.length,n.length)}return""},handle_item_removal_from_wishlist_page:function(){t("body").on("alg_wc_wl_toggle_wl_item",function(o){o.response.success&&(jQuery(".alg-wc-wl-view-table").length&&o.target.parents("tr").remove(),0==jQuery(".alg-wc-wl-view-table tbody tr").length&&(jQuery(".alg-wc-wl-view-table").remove(),jQuery(".alg-wc-wl-empty-wishlist").show(),t(".alg-wc-wl-social").remove()))})},convertToBoolean:function(t){return("string"==typeof t||t instanceof String)&&(t=t.toLowerCase()),Boolean(1==t|"true"===t)},toggle_wishlist_item:function(){var o=jQuery(alg_wc_wl_toggle_btn.btn_class+'[data-item_id="'+jQuery(this).attr("data-item_id")+'"]'),i=jQuery(this),e=alg_wc_wl_get_toggle_wishlist_item_data(i);i.hasClass("loading")||(i.addClass("loading"),jQuery.post(alg_wc_wl.ajaxurl,e,function(e){e.success&&(o.hasClass("remove")?(o.removeClass("remove"),o.addClass("add")):(o.removeClass("add"),o.addClass("remove"))),t("body").trigger({type:"alg_wc_wl_toggle_wl_item",item_id:i.attr("data-item_id"),target:i,response:e}),alg_wc_wish_list.show_notification(e),i.removeClass("loading")}))},is_mobile:function(){return window.innerWidth<=800||window.innerHeight<=600},get_notification_option:function(o,i){var e=null;return"undefined"!=typeof i&&(e=i),"undefined"!=typeof alg_wc_wl_notification&&alg_wc_wl_notification.hasOwnProperty(o)&&!t.isEmptyObject(alg_wc_wl_notification[o])&&(e=alg_wc_wl_notification[o]),e},get_notification_icon:function(t){var o="fa fa-heart";switch(t.data.action){case"added":o=alg_wc_wish_list.get_notification_option("icon_add","fa fa-heart");break;case"removed":o=alg_wc_wish_list.get_notification_option("icon_remove","fa fa-heart-o");break;case"error":o=alg_wc_wish_list.get_notification_option("icon_error","fa fa-exclamation-circle");break;default:"undefined"!==t.data.icon&&(o=t.data.icon)}return o},show_notification:function(t){var o=!1;alg_wc_wish_list.convertToBoolean(alg_wc_wish_list.get_notification_option("mobile"))&&alg_wc_wish_list.is_mobile()?o=!0:alg_wc_wish_list.convertToBoolean(alg_wc_wish_list.get_notification_option("desktop"))&&!alg_wc_wish_list.is_mobile()&&(o=!0),o&&(iziToast.destroy(),iziToast.show({message:t.data.message,icon:alg_wc_wish_list.get_notification_icon(t)}))},setup_izitoast:function(){this.setup_notification_to_close_on_esc();var o={resetOnHover:!0,drag:!1,layout:2,theme:"dark",timeout:alg_wc_wish_list.get_notification_option("timeout",0),backgroundColor:"#000000",progressBar:alg_wc_wish_list.convertToBoolean(alg_wc_wish_list.get_notification_option("progressBar",!0)),position:alg_wc_wish_list.get_notification_option("position","center"),progressBarColor:"rgb(255, 255, 255)",class:"alg-wc-wl-izitoast",onClose:function(o,i,e){t("body").trigger({type:"alg_wc_wl_notification_close",message:jQuery(i).find("p.slideIn")})}};alg_wc_wish_list.convertToBoolean(alg_wc_wish_list.get_notification_option("ok_button",!1))&&(o.buttons=[["<button>OK</button>",function(t,o){t.hide({},o)}]]),iziToast.settings(o)},setup_notification_to_close_on_esc:function(){t(document).keyup(function(t){27==t.keyCode&&jQuery(".iziToast").length>0&&iziToast.hide({},".iziToast")})}},alg_wc_wish_list.init()}),jQuery(function(t){var o={init:function(){this.email_options_toggler(".alg-wc-wl-social-li .email",".alg-wc-wl-email-options"),this.handle_send_to_option(),this.handle_clipboard_button()},copyToClipboard:function(t){if(window.clipboardData&&window.clipboardData.setData)return clipboardData.setData("Text",t);if(document.queryCommandSupported&&document.queryCommandSupported("copy")){var o=document.createElement("textarea");o.textContent=t,o.style.position="fixed",document.body.appendChild(o),o.select();try{return document.execCommand("copy")}catch(t){return console.warn("Copy to clipboard failed.",t),!1}finally{document.body.removeChild(o)}}},handle_clipboard_button:function(){t("body").on("click",".alg-wc-wl-social-li .copy",function(i){i.preventDefault();var e=this.getAttribute("href");o.copyToClipboard(e),t("body").trigger({type:"alg_wc_wl_copied_to_clipboard",link:e})})},email_options_toggler:function(o,i){var e=-1;t("body").on("click",o,function(o){var _=t(this);o.preventDefault(),e*=-1,1==e?_.addClass("active"):_.removeClass("active"),t(i).slideToggle()})},handle_send_to_option:function(){t("body").on("change",'input[name="alg_wc_wl_email_send_to"]',function(o){var i=t(this).val();"friends"==i?t(".alg-wc-wl-emails-input").show():"admin"==i&&t(".alg-wc-wl-emails-input").hide()})}};o.init()});var alg_wc_wl_thumb_btn_positioner={thumb_btn:null,offset:0,offset_single:0,offset_loop:0,thumb_btn_position:"topRight",buttons_count:0,repeater:null,init:function(){this.thumb_btn=jQuery("."+this.get_thumb_option("thumb_css_class","alg-wc-wl-thumb-btn")),this.thumb_btn_position=this.get_thumb_option("position","topLeft"),this.offset=parseInt(this.get_thumb_option("offset_loop",17)),this.offset_single=parseInt(this.get_thumb_option("offset_single",17)),this.offset_loop=parseInt(this.get_thumb_option("offset_loop",17)),this.thumb_btn.css("left","auto").css("top","auto").css("right","auto").css("bottom","auto"),this.position_btns_looping(),window.onresize=function(t){clearInterval(alg_wc_wl_thumb_btn_positioner.repeater),alg_wc_wl_thumb_btn_positioner.position_btns_looping()}},position_btns_looping:function(){this.repeater=setInterval(function(){alg_wc_wl_thumb_btn_positioner.position_btns()},200)},position_btns:function(){alg_wc_wl_thumb_btn_positioner.thumb_btn.each(function(){var t=alg_wc_wl_thumb_btn_positioner.offset,o=alg_wc_wl_thumb_btn_positioner.offset_single,i=alg_wc_wl_thumb_btn_positioner.offset_loop,e=!1;jQuery(this).hasClass("alg-wc-wl-thumb-btn-loop")?(t=i,e=!1):jQuery(this).hasClass("alg-wc-wl-thumb-btn-single")&&(t=o,e=!0);var _=jQuery(this).parent().find("img").eq(0);if(_.offset()&&_.parent().offset){var n=_.height()-jQuery(this).height()-t,a=t,l=t+_.offset().left-_.parent().offset().left,s=t+_.offset().left-_.parent().offset().left;if(alg_wc_wl_thumb_btn_positioner.thumb_btn_position.match(/bottom/i)&&jQuery(this).css("top",n),alg_wc_wl_thumb_btn_positioner.thumb_btn_position.match(/top/i)&&jQuery(this).css("top",a),alg_wc_wl_thumb_btn_positioner.thumb_btn_position.match(/right/i)&&jQuery(this).css("right",s),alg_wc_wl_thumb_btn_positioner.thumb_btn_position.match(/left/i)&&jQuery(this).css("left",l),e&&!jQuery(this).hasClass("positioned-on-parent")){var c=jQuery(this).parent().parent();c.append(jQuery(this)),jQuery(this).addClass("positioned-on-parent")}jQuery(this).show(),alg_wc_wl_thumb_btn_positioner.buttons_count++,alg_wc_wl_thumb_btn_positioner.stopRepeater()}})},stopRepeater:function(){alg_wc_wl_thumb_btn_positioner.buttons_count==alg_wc_wl_thumb_btn_positioner.thumb_btn.length&&(clearInterval(alg_wc_wl_thumb_btn_positioner.repeater),alg_wc_wl_thumb_btn_positioner.buttons_count=0)},get_thumb_option:function(t,o){var i=null;return"undefined"!=typeof o&&(i=o),"undefined"!=typeof alg_wc_wl_thumb&&alg_wc_wl_thumb.hasOwnProperty(t)&&!jQuery.isEmptyObject(alg_wc_wl_thumb[t])&&(i=alg_wc_wl_thumb[t]),i}};jQuery(function(t){alg_wc_wl_thumb_btn_positioner.init(),jQuery("body").trigger({type:"alg_wc_wl_thumb_btn_position",obj:alg_wc_wl_thumb_btn_positioner})});var alg_wc_wl_counter={};jQuery(function(t){alg_wc_wl_counter={counter_selector:".alg-wc-wl-counter",init:function(){t("body").on("alg_wc_wl_toggle_wl_item",function(o){t(alg_wc_wl_counter.counter_selector).length&&alg_wc_wl_counter.update_counter()})},update_counter:function(){t(alg_wc_wl_counter.counter_selector).length&&t.post(alg_wc_wl.ajaxurl,{action:alg_wc_wl_get_wl_ajax_action,ignore_excluded_items:!0},function(o){if(o.success){var i=o.data.wishlist;t(alg_wc_wl_counter.counter_selector).html(i.length)}})}},alg_wc_wl_counter.init(),t("body").trigger({type:"alg_wc_wl_counter",obj:alg_wc_wl_counter})});